package com.qihoo.speechdemo;

import java.util.ArrayList;
import java.util.List;

import com.qihoo.speechrecognition.QihooSpeechRecognizer;
import com.qihoo.speechrecognition.ui.ASRDialog;
import com.qihoo.speechrecognition.ui.ASRDialogListener;
import com.qihoo.speechrecognition.R;

import android.app.Activity;
import android.os.Bundle;
import android.speech.SpeechRecognizer;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;

public class SearchBoxActivity extends Activity  {

	private static final String TAG = "SEARCH_BOX_ACTIVITY";
	
	private static final String APP_ID = "voice_test";
	private static final String SECURET_KEY = "CbzUNsiSyt+4mcO44DCvC5Kb1sk=";
	
	
	private EditText recognitionContent;
	private EditText searchContent;
	//private Spinner spnrContent;
	private ImageButton  btnSpeech ;
	
	
	 protected void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        
	        
	        
	        setContentView(R.layout.search_box);
	        btnSpeech = (ImageButton)findViewById(R.id.activity_btn_audio);
	        recognitionContent = (EditText)findViewById(R.id.activity_edtxt_content);
	        searchContent = (EditText)findViewById(R.id.activity_edtxt_search_content);
	        //spnrContent = (Spinner) findViewById(R.id.activity_spnr_content);
	        
	        btnSpeech.setOnTouchListener(new View.OnTouchListener() {
	             
	             @Override
	             public boolean onTouch(View v, MotionEvent event) {
	            	  
	                 if (MotionEvent.ACTION_DOWN == event.getAction()) {
	                     Log.d(TAG, "speech button is pressed down");
	                     //recognitionContent.setText("");
	                     Bundle params = new Bundle();
	                     params.putString(ASRDialog.KEY_APP_ID, APP_ID);
	                     params.putString(ASRDialog.KEY_SECURET_KEY, SECURET_KEY);
	                    // params.putString(ASRDialog.k,);
	                     ASRDialog dialog = new ASRDialog(SearchBoxActivity.this, R.style.AsrDialog,params);
	                     if(ASRDialog.INITSTATE_SUCCESS != dialog.getInitState()){
	                    	 Log.e(TAG, "dialog init error!");
	                    	 return false;
	                     }
	                     dialog.setListener(listener);
	                     dialog.show();  
	                     setTitle("SpeechDemo(" + dialog.getSDKVersion() + " " + APP_ID + ")");
	                 }
	                 
	                 return false; 
	             }
	         });
	 }
	 
	 public void onDestroy(){
	    	super.onDestroy();
	    }
	 
	 
	 private ASRDialogListener listener = new ASRDialogListener(){

			@Override
			public void onResults(Bundle results) {
				
				Log.d(TAG, "onResults()");
				
				if (null == results) {
	                return;
	            }
	            List<String> strList = results.getStringArrayList(QihooSpeechRecognizer.RESULTS_RECOGNITION);
	            String reqId = results.getString(QihooSpeechRecognizer.RESULTS_REQUESTID);
	            Log.i(TAG, "req_id:" + reqId);
	            
	            if (null!=strList && strList.size()>0 ) {
	                String result = strList.get(0); 
	                //LogUtils.d(TAG, "recognition result = "+result);
	                recognitionContent.setText(result);
	            	
	              
	                String nBestResult = "";
	                for(int i=0;i<strList.size();i++){
	                	nBestResult += strList.get(i) + "\n";
	                }
	                searchContent.setText(nBestResult);
	            } else {
	                Log.d(TAG, "no recognition result");
	            }
			}
			
			public void onPartialResults(Bundle results) {
				
				Log.d(TAG, "onResults()");
				
				if (null == results) {
	                return;
	            }
	            ArrayList<String> strList = results.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION);
	            
	            if (null!=strList && strList.size()>0) {
	                String result = strList.get(0); 
	                Log.d(TAG, "recognition result = "+result);
	                recognitionContent.setText(result);
	            } else {
	                Log.d(TAG, "no recognition result");
	            }
			}
	    	
	    };
	
}
